<?php

namespace FiloBlu\CategoryPagination\Plugin\Model\ResourceModel\Product;

/**
 * Class Collection
 * @package FiloBlu\CategoryPagination\Plugin\Model\ResourceModel\Product
 */
class Collection
{

    /**
     * @var \Magento\Framework\Registry
     */
    protected $registry;
    /**
     * @var \FiloBlu\CategoryPagination\Helper\Data
     */
    protected $helper;
    /**
     * @var \Magento\Catalog\Block\Product\ProductList\Toolbar
     */
    protected $_toolbar;

    /**
     * Collection constructor.
     * @param \Magento\Framework\Registry $registry
     * @param \FiloBlu\CategoryPagination\Helper\Data $helper
     * @param \Magento\Catalog\Block\Product\ProductList\Toolbar $_toolbar
     */
    public function __construct(
        \Magento\Framework\Registry $registry,
        \FiloBlu\CategoryPagination\Helper\Data $helper,
        \Magento\Catalog\Block\Product\ProductList\Toolbar $_toolbar)
    {
        $this->registry = $registry;
        $this->helper = $helper;
        $this->_toolbar = $_toolbar;
    }

    /**
     * @param \Magento\Catalog\Model\ResourceModel\Product\Collection $collection
     * @return float|int
     */
    public function afterGetLastPageNumber(\Magento\Catalog\Model\ResourceModel\Product\Collection $collection)
    {

        $collectionSize = (int)$collection->getSize();

        if (0 === $collectionSize) {
            return 1;
        }

        $listMode = $this->_toolbar->getCurrentMode();

        $_categoryId = -1;

        if ($this->registry->registry('current_category')) {
            $_categoryId = $this->registry->registry('current_category')->getId();
        }

        $productNumberPage1 = $this->helper->getProductNumber($listMode, 1, $_categoryId);
        $productNumberPageOther = $this->helper->getProductNumber($listMode, 2, $_categoryId);

        $sizeFromSecondPage = $collectionSize - $productNumberPage1;

        if ($sizeFromSecondPage > 0) {
            return ceil($sizeFromSecondPage / $productNumberPageOther) + 1;
        }

        return 1;

    }
}
